#!/bin/sh
#
# $Id: autogen.sh 2312 2009-04-15 17:31:24Z mmamonski $
#
# Copyright 2006-2009 QCG Project Team
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

run()
{
	echo "Running $@..."
	eval "$@"
}

check()
{
	printf "Checking for $1... "
	if ($1 --version < /dev/null > /dev/null 2>&1); then
		echo "yes"
	else
		echo "no"
		exit 1
	fi
}

ACLOCAL=${ACLOCAL:=aclocal}
AUTOHEADER=${AUTOHEADER:=autoheader}
AUTOCONF=${AUTOCONF:=autoconf}
LIBTOOLIZE=${LIBTOOLIZE:=libtoolize}
AUTOMAKE=${AUTOMAKE:=automake}

check $ACLOCAL
check $AUTOHEADER
check $AUTOCONF
check $LIBTOOLIZE
check $AUTOMAKE

mkdir -p scripts

run $ACLOCAL -I m4 || exit 1
run $LIBTOOLIZE --copy --automake || exit 1
run $AUTOHEADER -Wall || exit 1
run $AUTOMAKE -Wall --copy --add-missing || exit 1
run $AUTOCONF -Wall -Wno-obsolete || exit 1

if test "$*"; then
	ARGS="$*"
else
	test -f config.log && ARGS=`grep '^  \$ \./configure ' config.log | sed 's/^  \$ \.\/configure //' 2>/dev/null`
fi

run ./configure $ARGS
