package com.qcg.comp.sdk.exceptions;

import java.util.List;

public class QCGCompException extends Exception {

	private static final long serialVersionUID = 1L;
	protected String infoMessage;

	public QCGCompException() {
		super();
	}

	public QCGCompException(String arg0, Throwable arg1) {
		super(arg0, arg1);
	}

	public QCGCompException(String arg0) {
		super(arg0);
	}

	public QCGCompException(Throwable arg0) {
		super(arg0);
	}
	
	protected void setInfoMessage(List<String> list){
		if (list.size()!=0) {
			StringBuffer sb = new StringBuffer(128 * list.size());

			for (String el: list) {
				if (sb.length() != 0)
					sb.append(',');
				
				sb.append(el);
			}
			
			infoMessage = sb.toString();
		}
	}
	
	protected void setInfoMessage(String message, List<String> list){
		if (list.size()!=0) {
			StringBuffer sb = new StringBuffer(128 * list.size());

			for (String el: list) {
				if (sb.length() != 0)
					sb.append(',');
				
				sb.append(el);
			}
			
			infoMessage = message + " - " + sb.toString();
		} else {
			infoMessage = message;
		}
	}
	
	public String getInfoMessage() {
		return infoMessage;
	}
	
	@Override
	public String getMessage() {
		if (infoMessage == null)
			return super.getMessage();
		else
			return super.getMessage() + " : " +  infoMessage;
	}
}
