package com.qcg.comp.sdk.socks;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketAddress;

public class SocksSocket extends Socket {
        
    protected SocketAddress proxy;
    protected String token;
    
    public SocksSocket() {
	
    }
    
    public void setProxy(InetSocketAddress proxy) {
	this.proxy = proxy;
    }
    
    public void setToken(String token) {
	this.token = token;
    }
    
    protected void negotiate(InetSocketAddress endpoint) throws IOException {
	byte[] request = new byte[]{0x04,0x01};
	byte[] response = new byte[8];
	int pos = 0;
	
	this.getOutputStream().write(request);	
	this.getOutputStream().write(endpoint.getPort()>>8);
	this.getOutputStream().write(endpoint.getPort());
	this.getOutputStream().write(endpoint.getAddress().getAddress());
	this.getOutputStream().write(token.getBytes());
	this.getOutputStream().write(0);
	
	while(pos < 8)
	    pos += this.getInputStream().read(response, pos, 8-pos);
	
	if(response[0] != 0 || response[1] != 90)
	    throw new IOException("Socks server returned garbage");
    }
    
    public void connect(InetSocketAddress endpoint) throws IOException { 	
	super.connect(proxy);
	negotiate(endpoint);
    }
}
