package com.qcg.comp.sdk.types;

import java.util.Date;

public class FileInfo {

     public static final int S_IFIFO  = 0010000;  /* named pipe (fifo) */
     public static final int S_IFCHR  = 0020000;  /* character special */
     public static final int S_IFDIR  = 0040000;  /* directory */
     public static final int S_IFBLK  = 0060000;  /* block special */
     public static final int S_IFREG  = 0100000;  /* regular */
     public static final int S_IFLNK  = 0120000;  /* symbolic link */
     public static final int S_IFSOCK = 0140000;  /* socket */
     public static final int S_IFWHT  = 0160000;  /* whiteout */
     public static final int S_ISUID  = 0004000;  /* set user id on execution */
     public static final int S_ISGID  = 0002000;  /* set group id on execution */
     public static final int S_ISVTX  = 0001000;  /* save swapped text even after use */
     public static final int S_IRUSR  = 0000400;  /* read permission, owner */
     public static final int S_IWUSR  = 0000200;  /* write permission, owner */
     public static final int S_IXUSR  = 0000100;  /* execute/search permission, owner */


    private Date accessTime, creationTime, modificationTime;
    private String owner, group;
    private int mode, nlink;
    private long size;

    public FileInfo(int mode, int nlink, String uid, String gid, long size,
	    Date aTime, Date cTime, Date mTime) {
	this.mode = mode;
	this.nlink = nlink;
	this.size = size;
	this.owner = uid;
	this.group = gid;
	this.accessTime = aTime;
	this.creationTime = cTime;
	this.modificationTime = mTime;
    }

    public Date getAccessTime() {
	return accessTime;
    }

    public Date getCreationTime() {
	return creationTime;
    }

    public Date getModificationTime() {
	return modificationTime;
    }

    public String getOwner() {
	return owner;
    }

    public String getGroup() {
	return group;
    }

    public int getMode() {
	return mode;
    }

    public int getNlink() {
	return nlink;
    }

    public long getSize() {
	return size;
    }
}
