package com.qcg.comp.tests;

import java.util.Date;

import com.qcg.comp.sdk.ardl.ARDL;
import com.qcg.comp.sdk.jsdl.JSDL;
import com.qcg.comp.sdk.types.ActivityEndpointReference;
import com.qcg.comp.sdk.types.QCGActivityStatus;

/**
 * Unit test for simple App.
 */
public class ARTwoCpuTest extends QCGCompConfig
{
 
	@Override
	protected void setUp() throws Exception {
		super.setUp();
	}
	
	public void testReservationTwoCpu() throws Exception {

		try {
			ARDL ardl = new ARDL(160);
			ardl.setTotalSlotsCount(2);
			ardl.setUserName(username1);
			
			resEpr1 = ares.createReservation(ardl);
			
			System.err.println("Reservation created: " + resEpr1);
			
			JSDL jsdl = new JSDL("sleep");
			jsdl.setExecutable("/bin/sleep");
			jsdl.getArguments().add("40");
			jsdl.setUserName(username1);
			jsdl.setReservationIdentifier(resEpr1);
			
			ActivityEndpointReference jobEpr1 = factory.createActivity(jsdl);
			ActivityEndpointReference jobEpr2 = factory.createActivity(jsdl);
	
			System.err.println("Jobs submitted = " + new Date());
			
			System.err.println("jobEpr1 = " + jobEpr1);
			System.err.println("jobEpr2 = " + jobEpr2);
	
			waitForState(jobEpr1, QCGActivityStatus.QCG_ACTIVITY_STATE_EXECUTING);
			System.err.println("Job1 started = " + new Date());
			
			waitForState(jobEpr2, QCGActivityStatus.QCG_ACTIVITY_STATE_EXECUTING);
			System.err.println("Job2 started = " + new Date());
			
			
			waitForTermination(jobEpr1);
			waitForTermination(jobEpr2);
	
			assertEquals(QCGActivityStatus.QCG_ACTIVITY_STATE_FINISHED, factory.getActivityStatus(jobEpr1).getState());
			assertEquals(QCGActivityStatus.QCG_ACTIVITY_STATE_FINISHED, factory.getActivityStatus(jobEpr1).getState());
			
			System.err.println("Job1 finished = " + new Date());
			System.err.println("Job2 finished = " + new Date());
		} catch (Exception ex) {
			ex.printStackTrace();
			fail();
		} finally {
			ares.terminateReservation(resEpr1);
		}
	}
	
}
