package com.qcg.comp.tests;



import java.util.concurrent.Callable;
import java.util.concurrent.Future;

import com.qcg.comp.sdk.jsdl.JSDL;
import com.qcg.comp.sdk.types.QCGActivityStatus;


/**
 * Unit test for simple App.
 */
public class TerminateJobMultiuserTest 
    extends QCGCompConfig
{
	
	
	@Override
	protected void setUp() throws Exception {
		super.setUp();
	}

	public void testMultiuserSleepKill() throws Throwable {
		
		jsdl = new JSDL("sleep");
		jsdl.setExecutable("/bin/sleep");
		jsdl.getArguments().add("120");
		
		
		jsdl.setUserName(username1);
		jobEpr1 = factory.createActivity(jsdl);
		
		System.err.println("jobEpr of " + username1  + " = "  + jobEpr1);

		jsdl.setUserName(username2);
		jobEpr2 = factory.createActivity(jsdl);
		
		System.err.println("jobEpr of " + username2  + " = "  + jobEpr2);
		
		
		Future<Object> f1 = pool.submit(new Callable<Object>() {

			public Object call() throws Exception {
				waitForState(jobEpr2, QCGActivityStatus.QCG_ACTIVITY_STATE_EXECUTING);
				return null;
			}
			
		});
		
		Future<Object> f2 = pool.submit(new Callable<Object>() {

			public Object call() throws Exception {
				waitForState(jobEpr2, QCGActivityStatus.QCG_ACTIVITY_STATE_EXECUTING);
				return null;
			}
			
		});
		
		f1.get();
		f2.get();
		
		waitForState(jobEpr2, QCGActivityStatus.QCG_ACTIVITY_STATE_EXECUTING);
		
		factory.terminateActivity(jobEpr1);
		factory.terminateActivity(jobEpr2);
		
		waitForTermination(jobEpr1);
		waitForTermination(jobEpr2);
		
		assertEquals(factory.getActivityStatus(jobEpr1).getState(), QCGActivityStatus.QCG_ACTIVITY_STATE_CANCELLED);
		assertEquals(factory.getActivityStatus(jobEpr2).getState(), QCGActivityStatus.QCG_ACTIVITY_STATE_CANCELLED);

	}

	
}
