package com.qcg.comp.tests.authentication;

import java.io.IOException;
import java.security.GeneralSecurityException;

import javax.xml.bind.JAXBException;

import junit.framework.TestCase;

import com.qcg.comp.client.QCGComputingClient;
import com.qcg.comp.sdk.QCGFactory;
import com.qcg.comp.sdk.exceptions.CantApplyOperationToCurrentStateException;
import com.qcg.comp.sdk.exceptions.InvalidRequestMessageException;
import com.qcg.comp.sdk.exceptions.NotAuthorizedException;
import com.qcg.comp.sdk.exceptions.UnknownActivityIdentifierException;
import com.qcg.comp.sdk.exceptions.UnsupportedFeatureException;
import com.qcg.comp.sdk.jsdl.JSDL;
import com.qcg.comp.sdk.types.ActivityEndpointReference;
import com.qcg.core.sdk.security.gsi.GSIAuthentication;
import com.qcg.core.sdk.security.ssl.SSLAuthentication;
import com.qcg.core.sdk.security.wsse.WSSEAuthentication;
import com.qcg.core.sdk.security.wsse.username.UsernameToken;
import com.sun.corba.se.spi.orbutil.threadpool.ThreadPool;

public class GSIAuthenticationTest extends TestCase {
	
	static final String QCG_COMP_HOST = "grass1.man.poznan.pl";
	
	static final int QCG_COMP_PORT = 19002;
	static final String QCG_COMP_DN = "/C=PL/O=GRID/O=PSNC/CN=host/grass1.man.poznan.pl";
	static final int THREADS_COUNT = 2;
	
	public void testGSI() throws InvalidRequestMessageException, NotAuthorizedException, UnsupportedFeatureException, JAXBException, CantApplyOperationToCurrentStateException, UnknownActivityIdentifierException, IOException, GeneralSecurityException, InterruptedException {

		QCGComputingClient.initGSICredentials();
		
		final QCGFactory executionFactory = new QCGFactory(QCG_COMP_HOST, QCG_COMP_PORT, new GSIAuthentication(QCG_COMP_HOST), true);
		
		Thread t[] = new Thread[THREADS_COUNT];
		
		for (int i = 0; i < THREADS_COUNT; i++) {
			t[i] = new Thread() {
				public void run() {
					System.err.println(executionFactory.getFactoryAttributesDocument());
				}
			};
			t[i].run();
			
		}
		
		for (int i=0; i < THREADS_COUNT; i++) {
			t[i].join();
		}
		
		
	}
	

}
