DROP TABLE reservations CASCADE;
DROP TABLE hosts CASCADE;

CREATE TABLE reservations
(
 uuid VARCHAR(64) PRIMARY KEY,
 cluster_name VARCHAR(64),
 drms_id VARCHAR(64),
 name VARCHAR(128),
 start_time TIMESTAMP WITH TIME ZONE,
 end_time TIMESTAMP WITH TIME ZONE,
 username VARCHAR(255),
 description VARCHAR(512),
 rtype VARCHAR(32) NOT NULL CHECK (rtype in ('user', 'system'))
);

CREATE TABLE hosts
(
 res_uuid VARCHAR(64) REFERENCES reservations(uuid) ON DELETE CASCADE,
 hostname VARCHAR(255) NOT NULL,
 reserved_cpus INTEGER NOT NULL,
 total_cpus INTEGER NOT NULL,
 used_cpus INTEGER
);

--INSERT INTO reservations VALUES ('urn:uuid:ea9b8a5f-059b-427a-92d1-39bc92f4b47d', 'psnc', 'usecase9#0', 'qcg1234', CURRENT_TIMESTAMP, CURRENT_TIMESTAMP + interval '1 hour', 'usecase9', 'user');
--INSERT INTO hosts VALUES ('urn:uuid:ea9b8a5f-059b-427a-92d1-39bc92f4b47d', 'node2.qoscosgrid.man.poznan.pl', 2, 4, 0);
--INSERT INTO hosts VALUES ('urn:uuid:ea9b8a5f-059b-427a-92d1-39bc92f4b47d', 'node3.qoscosgrid.man.poznan.pl', 1, 4, 0);
