/* $Id: extensions.c 2 2009-10-05 10:09:52Z mamonski $ */

/*
 * Copyright 2006-2009 QCG Project Team
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <qcg-core/sm.h>
#include <qcg-core/value.h>
#include <qcg-core/logger.h>
#include <qcg-core/modules/modules.h>

#include <common/extensions_internal.h>
#include <include/extensions.h>

static sm_value_t *smc_extensions = NULL;

sm_status_ret_code_t
smc_extensions_setup(void)
{
	SM_DEBUG_ENTER();

	return SM_OK;
}

void
smc_extensions_cleanup(void)
{
	SM_DEBUG_ENTER();

	sm_value_free(&smc_extensions);
}

sm_status_ret_code_t
smc_extensions_add(const char *anyURI)
{
	size_t i, count;

	SM_MANDATORY_P(anyURI);

	SM_DEBUG_ENTER_STR(anyURI);

	count = sm_value_count(smc_extensions);

	for (i = 0; i < count; i++)
		if (!strcmp(smc_extensions[i]->vstring, anyURI))
			return SM_OK;

	if (!sm_value_append(&smc_extensions, 1, SM_VALUE_STRING, anyURI))
		return SM_FAULT;

	return SM_OK;
}

sm_value_t *
smc_extensions_get(void)
{
	return smc_extensions;
}
