/* $Id: db_sandbox.h 24 2009-10-30 17:29:00Z mamonski $ */

/*
 * Copyright 2006-2009 QCG Project Team
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __SMC_DB_SANDBOX_H
#define __SMC_DB_SANDBOX_H

#include <qcg-core/sm.h>
#include <qcg-core/conf.h>
#include <qcg-core/odbc.h>

sm_status_ret_code_t smc_db_sandbox_setup(sm_conf_ctxt_t conf);
void smc_db_sandbox_cleanup(void);

int smc_db_sandbox_clear_accounts_pool_relation(void);
int smc_db_sandbox_add_account_entry(const char *name, const char *home_dir, int uid);
int smc_db_sandbox_acquire_account(char **account_name);
int smc_db_sandbox_release_account(const char *account_name, int (*purge_callback)(const char *username, const char *homedir, int uid));

#endif /* __SMC_DB_SANDBOX_H */
