/* $Id: bes_management.c 2 2009-10-05 10:09:52Z mamonski $ */

/*
 * Copyright 2006-2009 QCG Project Team
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <qcg-core/sm.h>
#include <qcg-core/logger.h>
#include <qcg-core/modules/modules.h>
#include <qcg-core/modules/ecm_gsoap/ecm_gsoap.h>

#include <faults.h>


#include <stub/qcgcompStub.h>

__SM_ID("$Id: bes_management.c 2 2009-10-05 10:09:52Z mamonski $");

SM_INTERNAL_GENERAL_MODULE = {
        .header = {
                .name = "bes_management"
        }
};

SM_BOOL smc_accepting_new_activities = SM_TRUE;

int
__bes_management__StopAcceptingNewActivities(
	struct soap *soap,
	struct bes_management__StopAcceptingNewActivitiesType *bes_management__StopAcceptingNewActivities sm_unused,
	struct bes_management__StopAcceptingNewActivitiesResponseType *bes_management__StopAcceptingNewActivitiesResponse sm_unused
)
{
	sm_transport_t transport = soap->user;
	struct sm_transport_fault_s faultstruct, *fault;

	SMC_FAULT_INIT;

	if (transport->enter(transport, "StopAcceptingNewActivities", fault) != SM_OK)
		return transport->fault(transport, fault);

	if (transport->access_check(transport, SM_FALSE, "StopAcceptingNewActivities", fault) != SM_ACCESS_GRANTED)
		return transport->fault(transport, fault);

	THROW_INTERNAL_FAULT("BES management port disabled.");
	/*
	TODO: make configurable
	sm_info("Stopped accepting new activities");
	smc_accepting_new_activities = SM_FALSE;
	*/

	return transport->exit(transport, NULL);
fault:
	return transport->fault(transport, fault);
}

int
__bes_management__StartAcceptingNewActivities(
	struct soap *soap,
	struct bes_management__StartAcceptingNewActivitiesType *bes_management__StartAcceptingNewActivities sm_unused,
	struct bes_management__StartAcceptingNewActivitiesResponseType *bes_management__StartAcceptingNewActivitiesResponse sm_unused
)
{
	sm_transport_t transport = soap->user;
	struct sm_transport_fault_s faultstruct, *fault;

	if (transport->enter(transport, "StartAcceptingNewActivities", fault) != SM_OK)
		return transport->fault(transport, fault);

	if (transport->access_check(transport, SM_FALSE, "StartAcceptingNewActivities", fault) != SM_ACCESS_GRANTED)
		return transport->fault(transport, fault);

	THROW_INTERNAL_FAULT("BES management port disabled.");
	/*
	TODO: make configurable
	sm_info("Started accepting new activities");
	smc_accepting_new_activities = SM_FALSE;
	*/

	return transport->exit(transport, NULL);
fault:
	return transport->fault(transport, fault);
}
