/* $Id: common.h 2 2009-10-05 10:09:52Z mamonski $ */

/*
 * Copyright 2006-2009 QCG Project Team
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __SMC_COMMON_H
#define __SMC_COMMON_H

#include <sys/types.h>

/*limit maximum size of the JSDL and ARDL documents. Prevents DOS attacks */
#define SMC_MAX_JSDL_LENGTH (128 * 1024)
#define SMC_MAX_ARDL_LENGTH (64 * 1024)

typedef void *(*smc_malloc_function)(void *ctxt, size_t size);
typedef char *(*smc_strdup_function)(void *ctxt, const char *str);

#endif /* __SMC_COMMON_H */
