/* $Id: user.h 2 2009-10-05 10:09:52Z mamonski $ */

/*
 * Copyright 2006-2009 QCG Project Team
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __SMC_USER_H
#define __SMC_USER_H

#include <sys/types.h>

#include <qcg-core/sm.h>
#include <qcg-core/access.h>

#include <job.h>

typedef enum {
	SMC_USER_OK = 0,
	SMC_USER_INTERNAL_FAULT = 1,
	SMC_USER_NO_MAPPING,
	SMC_USER_NOT_AUTHORIZED,
	SMC_USER_NOT_FOUND,
} smc_user_ret_code_t;

sm_ret_code_t smc_user_get_uid(const char *username, uid_t *uid);
sm_ret_code_t smc_user_get_home(const char *username, char **home);
sm_ret_code_t smc_user_handle_submission(const char *requested_username, sm_atc_token_t token, char **user, uid_t *uid);

typedef enum {
	SMC_USER_AUTH_GET_STATUS,
	SMC_USER_AUTH_GET_DOCUMENT,
	SMC_USER_AUTH_TERMINATE
} smc_user_auth_method_t;

sm_status_ret_code_t smc_user_authorize(smc_user_auth_method_t method, const char *owner, const char *subject);

#endif /* __SMC_USER_H */
