#ifndef INTERFACEH
#define INTERFACEH

#include <rsync/types.h>

#ifdef WITH_LIBRSYNC
#include <librsync.h>

struct rsync_delta_context
{
	rs_job_t *job;
	rs_signature_t *sig;
	rs_result status;

	char *delta;
	size_t delta_max_length;
	size_t delta_length;

	int fd;

	char *input;
	size_t input_max_length;
	size_t input_length;


	int wfd,rfd;
	char *path;
	char *output_fn;
};

int GetFiles(rsync_transport_t transport, const char *path, Files *files);
int GetSignature(rsync_transport_t transport, const char *basedir, const char *path, Signature *result);

int GetDeltaBegin(rsync_transport_t transport, const char *basedir, const char *path, const Signature *signature, struct rsync_delta_context **context);
int GetDeltaProcess(struct rsync_delta_context* context);
void GetDeltaFinish(struct rsync_delta_context* context);

int PutDeltaBegin(rsync_transport_t transport, const char *basedir, const char *path, struct rsync_delta_context **context);
int PutDeltaProcess(struct rsync_delta_context *context);
int PutDeltaFinish(struct rsync_delta_context *context);
void PutDeltaFree(struct rsync_delta_context *context);

int icomm_to_signature(rsync_transport_t transport, sm_value_t *result, Signature *sig);
int signature_to_icomm(rsync_transport_t transport, const Signature *signature, sm_value_t **icomm);
#endif

#endif //INTERFACEH
