#!/bin/sh 

module load openmpi/1.4.2-gcc-4.4

OMP_NUM_THREADS=`uniq -c $MACHINE_FILE | tr  -s '\t' ' ' | cut -f 2 -d ' ' | head -n 1`

if [ $QCG_COMP_PROCESSES_MAP"x" != "x" ]
then
	TEMP_MACHINE_FILE=`mktemp machinefile.unique.XXXXX`
	uniq $MACHINE_FILE > $TEMP_MACHINE_FILE 

	QCG_COMP_PROCESSES_MAP=`echo $QCG_COMP_PROCESSES_MAP | tr : ' '`

	TEMP_MACHINE_FILE_COUNT=`wc -l < $TEMP_MACHINE_FILE`
	QCG_COMP_PROCESSES_MAP_COUNT=`echo $QCG_COMP_PROCESSES_MAP | wc -w` 

	if [ $QCG_COMP_PROCESSES_MAP_COUNT -ne $TEMP_MACHINE_FILE_COUNT ]
	then 
		echo "Invalid QCG_COMP_PROCESSES_MAP value $QCG_COMP_PROCESSES_MAP_COUNT!=$TEMP_MACHINE_FILE_COUNT";
	fi

	QCG_COMP_PROCESSES_MAP_ARRAY=( $QCG_COMP_PROCESSES_MAP )
	TEMP_MACHINE_FILE_ARRAY=( `cat $TEMP_MACHINE_FILE` )

	: > $TEMP_MACHINE_FILE

	for (( i=0; i < $QCG_COMP_PROCESSES_MAP_COUNT; i++ ))
		do 
			for (( j=0; j < ${QCG_COMP_PROCESSES_MAP_ARRAY[$i]}; j++ )) 
			do 
				echo ${TEMP_MACHINE_FILE_ARRAY[$i]} >> $TEMP_MACHINE_FILE; 
			done 
		done


	export MACHINE_FILE=$TEMP_MACHINE_FILE
fi

mpi-start "$@"
EXIT_STATUS=$?

#cleanup
if [ $TEMP_MACHINE_FILE"x" != "x" ]
then
	rm $TEMP_MACHINE_FILE
fi

exit $EXIT_STATUS

